unit DMMainDataModule;

interface

uses
  SysUtils, Classes, JvComponent, JvAppStorage, JvAppRegistryStorage,
  JvFormPlacement;

type
  TMainDM = class(TDataModule)
    MainRegistryStorage: TJvAppRegistryStorage;
    StringStorage: TJvFormStorage;
    IntegerStorage: TJvFormStorage;
    procedure DataModuleCreate(Sender: TObject);
  private
    { Private declarations }
  public
    procedure RetrieveAllValues;
    procedure SetFakeDefaults;
    procedure RestoreDesignTimeDefaults;
  end;

var
  MainDM: TMainDM;

implementation

{$R *.dfm}

uses
  CommonVars;

procedure TMainDM.DataModuleCreate(Sender: TObject);

begin
  MainRegistryStorage.Root := RootKey
end;

procedure TMainDM.RetrieveAllValues;

begin
  {Startup retrieve of all values }
  StringStorage.StoredValues.RestoreValues;
  IntegerStorage.StoredValues.RestoreValues;
  { String values }
  Developer_Name := StringStorage.StoredValue['Developer_Name'];
  My_Name := StringStorage.StoredValue['My_Name'];
  { Integer and Boolean value }
  This_Is_Boolean := IntegerStorage.StoredValue['This_Is_Boolean'];
  This_Is_Integer := IntegerStorage.StoredValue['This_Is_Integer']
end;

procedure TMainDM.SetFakeDefaults;

begin
  StringStorage.DefaultValue['Developer_Name', ''] := Fake_Dev_Name_Default;
  StringStorage.DefaultValue['My_Name', ''] := Fake_Name_Default;
  IntegerStorage.DefaultValue['This_Is_Boolean', False] := Fake_Bool_Default;
  IntegerStorage.DefaultValue['This_Is_Integer', 0] := Fake_Int_Default
end;

procedure TMainDM.RestoreDesignTimeDefaults;

begin
  StringStorage.DefaultValue['Developer_Name', ''] := '';
  StringStorage.DefaultValue['My_Name', ''] := '';
  IntegerStorage.DefaultValue['This_Is_Boolean', False] := False;
  IntegerStorage.DefaultValue['This_Is_Integer', 0] := 0
end;

end.
